/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 19 "../src/vlog/vlog-parse.y"

#include "util.h"
#include "diag.h"
#include "ident.h"
#include "lib.h"
#include "object.h"
#include "scan.h"
#include "vlog/vlog-node.h"
#include "vlog/vlog-phase.h"

#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define YYLTYPE loc_t
#define YYSTYPE yylval_t
#define YYTOKENTYPE token_t

#define YYEMPTY -2
#define YYEOF tEOF
#define YYerror -3
#define YYUNDEF tERROR

#define yylex processed_yylex

typedef struct _node_list node_list_t;

struct _node_list {
   node_list_t *next;
   node_list_t *tail;
   vlog_node_t  value;
};

static void yyerror(const char *s);

static void node_list_append(node_list_t **l, vlog_node_t v);
static void node_list_concat(node_list_t **a, node_list_t *b);
static node_list_t *node_list_single(vlog_node_t v);
static void node_list_free(node_list_t *l);

static void set_timescale(const char *unit_value, const char *unit_name,
                          const char *prec_value, const char *prec_name,
                          const loc_t *loc);
static void clone_port(node_list_t **list, vlog_node_t p);

#define YYLLOC_DEFAULT(Current, Rhs, N) {                            \
   if (N) {                                                          \
      (Current) = get_loc(YYRHSLOC(Rhs, 1).first_line,               \
                          YYRHSLOC(Rhs, 1).first_column,             \
                          YYRHSLOC(Rhs, N).first_line +              \
                          YYRHSLOC(Rhs, N).line_delta,               \
                          YYRHSLOC(Rhs, N).first_column +            \
                          YYRHSLOC(Rhs, N).column_delta,             \
                          YYRHSLOC(Rhs, N).file_ref);                \
   }                                                                 \
   else {                                                            \
      (Current) = YYRHSLOC(Rhs, 0);                                  \
   }                                                                 \
 }

static vlog_node_t root;

static void add_port(vlog_node_t module, vlog_node_t port)
{
   switch (vlog_kind(port)) {
   case V_PORT_DECL:
      {
         // Verilog-2001 style port declaration
         vlog_node_t ref = vlog_new(V_REF);
         vlog_set_loc(ref, vlog_loc(port));
         vlog_set_ident(ref, vlog_ident(port));
         vlog_set_ref(ref, port);

         vlog_add_port(module, ref);
         vlog_add_decl(module, port);
      }
      break;
   case V_REF:
      vlog_add_port(module, port);
      break;
   case V_NET_DECL:
   case V_VAR_DECL:
      vlog_add_decl(module, port);
      break;
   default:
      fatal_trace("unexpected %s in port list", vlog_kind_str(vlog_kind(port)));
   }
}

static bool is_decl(vlog_node_t v)
{
   switch (vlog_kind(v)) {
   case V_PORT_DECL:
   case V_NET_DECL:
   case V_VAR_DECL:
      return true;
   default:
      return false;
   }
}

static vlog_node_t make_strength(vlog_strength_t value, const loc_t *loc)
{
   vlog_node_t s = vlog_new(V_STRENGTH);
   vlog_set_loc(s, loc);
   vlog_set_subkind(s, value);
   return s;
}


#line 183 "src/vlog/vlog-parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    tEOF = 0,                      /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 411,                 /* "invalid token"  */
    tID = 200,                     /* "identifier"  */
    tSYSTASK = 383,                /* "system task identifier"  */
    tSTRING = 229,                 /* "string"  */
    tUNSIGNED = 359,               /* "unsigned number"  */
    tMODULE = 350,                 /* "module"  */
    tENDMODULE = 351,              /* "endmodule"  */
    tINPUT = 352,                  /* "input"  */
    tOUTPUT = 353,                 /* "output"  */
    tINOUT = 231,                  /* "inout"  */
    tREG = 354,                    /* "reg"  */
    tALWAYS = 336,                 /* "always"  */
    tINITIAL = 357,                /* "initial"  */
    tPOSEDGE = 355,                /* "posedge"  */
    tNEGEDGE = 356,                /* "negedge"  */
    tBEGIN = 211,                  /* "begin"  */
    tEND = 203,                    /* "end"  */
    tLE = 294,                     /* "<="  */
    tWIRE = 358,                   /* "wire"  */
    tASSIGN = 227,                 /* "assign"  */
    tIF = 234,                     /* "if"  */
    tELSE = 255,                   /* "else"  */
    tTIMESCALE = 399,              /* "`timescale"  */
    tSUPPLY0 = 400,                /* "supply0"  */
    tSUPPLY1 = 401,                /* "supply1"  */
    tPULLDOWN = 402,               /* "pulldown"  */
    tPULLUP = 403,                 /* "pullup"  */
    tCASEEQ = 404,                 /* "==="  */
    tCASENEQ = 405,                /* "!=="  */
    tLOGEQ = 406,                  /* "=="  */
    tLOGNEQ = 407,                 /* "!="  */
    tATTRBEGIN = 408,              /* "(*"  */
    tATTREND = 409,                /* "*)"  */
    tNUMBER = 410                  /* "number"  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;

int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_tID = 3,                        /* "identifier"  */
  YYSYMBOL_tSYSTASK = 4,                   /* "system task identifier"  */
  YYSYMBOL_tSTRING = 5,                    /* "string"  */
  YYSYMBOL_tUNSIGNED = 6,                  /* "unsigned number"  */
  YYSYMBOL_tMODULE = 7,                    /* "module"  */
  YYSYMBOL_tENDMODULE = 8,                 /* "endmodule"  */
  YYSYMBOL_tINPUT = 9,                     /* "input"  */
  YYSYMBOL_tOUTPUT = 10,                   /* "output"  */
  YYSYMBOL_tINOUT = 11,                    /* "inout"  */
  YYSYMBOL_tREG = 12,                      /* "reg"  */
  YYSYMBOL_tALWAYS = 13,                   /* "always"  */
  YYSYMBOL_tINITIAL = 14,                  /* "initial"  */
  YYSYMBOL_tPOSEDGE = 15,                  /* "posedge"  */
  YYSYMBOL_tNEGEDGE = 16,                  /* "negedge"  */
  YYSYMBOL_tBEGIN = 17,                    /* "begin"  */
  YYSYMBOL_tEND = 18,                      /* "end"  */
  YYSYMBOL_tLE = 19,                       /* "<="  */
  YYSYMBOL_tWIRE = 20,                     /* "wire"  */
  YYSYMBOL_tASSIGN = 21,                   /* "assign"  */
  YYSYMBOL_tIF = 22,                       /* "if"  */
  YYSYMBOL_tELSE = 23,                     /* "else"  */
  YYSYMBOL_tTIMESCALE = 24,                /* "`timescale"  */
  YYSYMBOL_tSUPPLY0 = 25,                  /* "supply0"  */
  YYSYMBOL_tSUPPLY1 = 26,                  /* "supply1"  */
  YYSYMBOL_tPULLDOWN = 27,                 /* "pulldown"  */
  YYSYMBOL_tPULLUP = 28,                   /* "pullup"  */
  YYSYMBOL_tCASEEQ = 29,                   /* "==="  */
  YYSYMBOL_tCASENEQ = 30,                  /* "!=="  */
  YYSYMBOL_tLOGEQ = 31,                    /* "=="  */
  YYSYMBOL_tLOGNEQ = 32,                   /* "!="  */
  YYSYMBOL_tATTRBEGIN = 33,                /* "(*"  */
  YYSYMBOL_tATTREND = 34,                  /* "*)"  */
  YYSYMBOL_tNUMBER = 35,                   /* "number"  */
  YYSYMBOL_36_ = 36,                       /* '|'  */
  YYSYMBOL_37_ = 37,                       /* '&'  */
  YYSYMBOL_38_ = 38,                       /* '+'  */
  YYSYMBOL_39_ = 39,                       /* '-'  */
  YYSYMBOL_40_ = 40,                       /* '*'  */
  YYSYMBOL_41_ = 41,                       /* '/'  */
  YYSYMBOL_42_ = 42,                       /* '%'  */
  YYSYMBOL_43_ = 43,                       /* '~'  */
  YYSYMBOL_44_ = 44,                       /* '!'  */
  YYSYMBOL_45_then_ = 45,                  /* "then"  */
  YYSYMBOL_46_ = 46,                       /* ';'  */
  YYSYMBOL_47_ = 47,                       /* '('  */
  YYSYMBOL_48_ = 48,                       /* ')'  */
  YYSYMBOL_49_ = 49,                       /* ','  */
  YYSYMBOL_50_ = 50,                       /* '['  */
  YYSYMBOL_51_ = 51,                       /* ':'  */
  YYSYMBOL_52_ = 52,                       /* ']'  */
  YYSYMBOL_53_ = 53,                       /* '='  */
  YYSYMBOL_54_ = 54,                       /* '#'  */
  YYSYMBOL_55_ = 55,                       /* '@'  */
  YYSYMBOL_YYACCEPT = 56,                  /* $accept  */
  YYSYMBOL_source_text = 57,               /* source_text  */
  YYSYMBOL_directive_list = 58,            /* directive_list  */
  YYSYMBOL_timescale_compiler_directive = 59, /* timescale_compiler_directive  */
  YYSYMBOL_description = 60,               /* description  */
  YYSYMBOL_61_1 = 61,                      /* $@1  */
  YYSYMBOL_attr_spec = 62,                 /* attr_spec  */
  YYSYMBOL_attr_list_opt = 63,             /* attr_list_opt  */
  YYSYMBOL_module_declaration = 64,        /* module_declaration  */
  YYSYMBOL_module_port_list_opt = 65,      /* module_port_list_opt  */
  YYSYMBOL_list_of_ports = 66,             /* list_of_ports  */
  YYSYMBOL_port = 67,                      /* port  */
  YYSYMBOL_port_reference = 68,            /* port_reference  */
  YYSYMBOL_port_identifier = 69,           /* port_identifier  */
  YYSYMBOL_list_of_port_declarations = 70, /* list_of_port_declarations  */
  YYSYMBOL_range_opt = 71,                 /* range_opt  */
  YYSYMBOL_port_declaration_head = 72,     /* port_declaration_head  */
  YYSYMBOL_port_declaration = 73,          /* port_declaration  */
  YYSYMBOL_module_item_list_opt = 74,      /* module_item_list_opt  */
  YYSYMBOL_module_item_list = 75,          /* module_item_list  */
  YYSYMBOL_module_item = 76,               /* module_item  */
  YYSYMBOL_module_or_generate_item = 77,   /* module_or_generate_item  */
  YYSYMBOL_module_instantiation = 78,      /* module_instantiation  */
  YYSYMBOL_module_instance = 79,           /* module_instance  */
  YYSYMBOL_list_of_port_connections_opt = 80, /* list_of_port_connections_opt  */
  YYSYMBOL_list_of_port_connections = 81,  /* list_of_port_connections  */
  YYSYMBOL_module_or_generate_item_declaration = 82, /* module_or_generate_item_declaration  */
  YYSYMBOL_net_declaration = 83,           /* net_declaration  */
  YYSYMBOL_net_type = 84,                  /* net_type  */
  YYSYMBOL_list_of_net_identifiers = 85,   /* list_of_net_identifiers  */
  YYSYMBOL_reg_declaration = 86,           /* reg_declaration  */
  YYSYMBOL_list_of_variable_identifiers = 87, /* list_of_variable_identifiers  */
  YYSYMBOL_variable_type = 88,             /* variable_type  */
  YYSYMBOL_continuous_assign = 89,         /* continuous_assign  */
  YYSYMBOL_list_of_net_assignments = 90,   /* list_of_net_assignments  */
  YYSYMBOL_net_assignment = 91,            /* net_assignment  */
  YYSYMBOL_always_construct = 92,          /* always_construct  */
  YYSYMBOL_initial_construct = 93,         /* initial_construct  */
  YYSYMBOL_statement = 94,                 /* statement  */
  YYSYMBOL_statement_or_null = 95,         /* statement_or_null  */
  YYSYMBOL_list_of_statements_opt = 96,    /* list_of_statements_opt  */
  YYSYMBOL_list_of_statements = 97,        /* list_of_statements  */
  YYSYMBOL_conditional_statement = 98,     /* conditional_statement  */
  YYSYMBOL_system_task_enable = 99,        /* system_task_enable  */
  YYSYMBOL_seq_block = 100,                /* seq_block  */
  YYSYMBOL_nonblocking_assignment = 101,   /* nonblocking_assignment  */
  YYSYMBOL_blocking_assignment = 102,      /* blocking_assignment  */
  YYSYMBOL_procedural_timing_control_statement = 103, /* procedural_timing_control_statement  */
  YYSYMBOL_delay_or_event_control = 104,   /* delay_or_event_control  */
  YYSYMBOL_delay_control = 105,            /* delay_control  */
  YYSYMBOL_delay_value = 106,              /* delay_value  */
  YYSYMBOL_event_control = 107,            /* event_control  */
  YYSYMBOL_event_expression = 108,         /* event_expression  */
  YYSYMBOL_lvalue = 109,                   /* lvalue  */
  YYSYMBOL_expression = 110,               /* expression  */
  YYSYMBOL_list_of_expressions = 111,      /* list_of_expressions  */
  YYSYMBOL_string = 112,                   /* string  */
  YYSYMBOL_primary = 113,                  /* primary  */
  YYSYMBOL_number = 114,                   /* number  */
  YYSYMBOL_decimal_number = 115,           /* decimal_number  */
  YYSYMBOL_hierarchical_identifier = 116,  /* hierarchical_identifier  */
  YYSYMBOL_identifier = 117,               /* identifier  */
  YYSYMBOL_external_identifier = 118,      /* external_identifier  */
  YYSYMBOL_gate_instantiation = 119,       /* gate_instantiation  */
  YYSYMBOL_pull_gate_instance = 120,       /* pull_gate_instance  */
  YYSYMBOL_pulldown_strength = 121,        /* pulldown_strength  */
  YYSYMBOL_pullup_strength = 122,          /* pullup_strength  */
  YYSYMBOL_strength0 = 123,                /* strength0  */
  YYSYMBOL_strength1 = 124                 /* strength1  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   331

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  56
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  69
/* YYNRULES -- Number of rules.  */
#define YYNRULES  137
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  263

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   412


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    44,     2,    54,     2,    42,    37,     2,
      47,    48,    40,    38,    49,    39,     2,    41,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    51,    46,
       2,    53,     2,     2,    55,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,    52,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    36,     2,    43,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     2,     2,    18,     2,     2,     2,     2,     2,     2,
       2,    17,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    21,     2,     5,
       2,    11,     2,     2,    22,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    23,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    19,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    13,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       7,     8,     9,    10,    12,    15,    16,    14,    20,     6,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     4,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,     2,    45
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   209,   209,   212,   213,   217,   223,   223,   224,   227,
     230,   231,   235,   261,   262,   263,   264,   267,   272,   275,
     278,   287,   297,   302,   307,   310,   318,   322,   330,   338,
     346,   364,   369,   373,   374,   378,   383,   387,   388,   392,
     393,   394,   395,   396,   397,   401,   409,   423,   424,   428,
     433,   437,   438,   442,   449,   468,   469,   470,   474,   483,
     495,   499,   516,   521,   528,   537,   541,   542,   549,   563,
     576,   588,   589,   590,   591,   592,   593,   597,   598,   602,
     604,   608,   613,   621,   633,   654,   662,   676,   685,   698,
     708,   719,   730,   731,   734,   742,   745,   748,   755,   762,
     771,   777,   786,   787,   788,   796,   804,   812,   820,   828,
     836,   843,   853,   858,   865,   875,   881,   888,   891,   892,
     901,   911,   914,   922,   933,   944,   951,   962,   972,   979,
     988,   994,  1000,  1008,  1014,  1020,  1027,  1030
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"system task identifier\"", "\"string\"", "\"unsigned number\"",
  "\"module\"", "\"endmodule\"", "\"input\"", "\"output\"", "\"inout\"",
  "\"reg\"", "\"always\"", "\"initial\"", "\"posedge\"", "\"negedge\"",
  "\"begin\"", "\"end\"", "\"<=\"", "\"wire\"", "\"assign\"", "\"if\"",
  "\"else\"", "\"`timescale\"", "\"supply0\"", "\"supply1\"",
  "\"pulldown\"", "\"pullup\"", "\"===\"", "\"!==\"", "\"==\"", "\"!=\"",
  "\"(*\"", "\"*)\"", "\"number\"", "'|'", "'&'", "'+'", "'-'", "'*'",
  "'/'", "'%'", "'~'", "'!'", "\"then\"", "';'", "'('", "')'", "','",
  "'['", "':'", "']'", "'='", "'#'", "'@'", "$accept", "source_text",
  "directive_list", "timescale_compiler_directive", "description", "$@1",
  "attr_spec", "attr_list_opt", "module_declaration",
  "module_port_list_opt", "list_of_ports", "port", "port_reference",
  "port_identifier", "list_of_port_declarations", "range_opt",
  "port_declaration_head", "port_declaration", "module_item_list_opt",
  "module_item_list", "module_item", "module_or_generate_item",
  "module_instantiation", "module_instance",
  "list_of_port_connections_opt", "list_of_port_connections",
  "module_or_generate_item_declaration", "net_declaration", "net_type",
  "list_of_net_identifiers", "reg_declaration",
  "list_of_variable_identifiers", "variable_type", "continuous_assign",
  "list_of_net_assignments", "net_assignment", "always_construct",
  "initial_construct", "statement", "statement_or_null",
  "list_of_statements_opt", "list_of_statements", "conditional_statement",
  "system_task_enable", "seq_block", "nonblocking_assignment",
  "blocking_assignment", "procedural_timing_control_statement",
  "delay_or_event_control", "delay_control", "delay_value",
  "event_control", "event_expression", "lvalue", "expression",
  "list_of_expressions", "string", "primary", "number", "decimal_number",
  "hierarchical_identifier", "identifier", "external_identifier",
  "gate_instantiation", "pull_gate_instance", "pulldown_strength",
  "pullup_strength", "strength0", "strength1", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-182)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-35)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -182,    20,    26,  -182,  -182,    22,  -182,  -182,  -182,    44,
      12,  -182,    16,    99,   104,  -182,    81,  -182,    62,  -182,
      88,   130,    24,   101,  -182,  -182,    87,     6,    87,  -182,
      83,  -182,  -182,    91,  -182,  -182,   217,   164,    99,    87,
      99,    99,  -182,   104,  -182,   308,   169,    93,   110,   137,
     242,  -182,  -182,  -182,  -182,  -182,   164,   164,   231,  -182,
    -182,  -182,  -182,   118,  -182,  -182,  -182,    99,  -182,  -182,
    -182,  -182,  -182,    11,    96,    96,  -182,   104,  -182,  -182,
       1,    43,  -182,  -182,  -182,    28,  -182,  -182,  -182,  -182,
     104,  -182,    99,  -182,  -182,  -182,  -182,  -182,   164,   164,
     164,   164,   164,   164,   164,   164,  -182,   164,    -7,  -182,
    -182,   112,    19,   115,   165,   146,  -182,  -182,  -182,  -182,
     139,   152,  -182,     8,  -182,  -182,    -4,   134,  -182,    46,
    -182,   156,   102,   158,   167,    50,   102,   170,    50,   164,
      55,  -182,   183,   187,  -182,   138,   138,   136,   162,  -182,
    -182,   181,   185,   247,  -182,   104,  -182,   164,   104,  -182,
     212,    96,   164,  -182,  -182,   120,  -182,  -182,  -182,  -182,
    -182,   164,   164,   164,  -182,   104,   164,  -182,  -182,   190,
     155,   205,   104,  -182,   104,   209,   226,   223,  -182,   213,
     251,  -182,   104,  -182,   104,  -182,  -182,  -182,   164,  -182,
     271,   225,    96,  -182,  -182,   267,   164,   164,   230,   271,
     271,   271,   206,  -182,   271,  -182,  -182,   268,   270,   245,
    -182,   268,  -182,   270,  -182,   164,  -182,  -182,   243,   210,
     253,   164,   294,     8,   271,   271,  -182,  -182,   265,   266,
    -182,   272,   273,   227,  -182,   104,   104,  -182,   271,  -182,
     293,  -182,  -182,  -182,  -182,   104,  -182,    65,     8,    70,
    -182,  -182,  -182
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     6,     1,     8,     0,     3,     2,    11,     0,
       0,     7,     0,     0,     0,    10,     0,   123,    16,   122,
       0,     0,     0,     0,     9,     5,    26,    26,    26,    15,
       0,    18,    19,     0,    24,    20,    11,     0,     0,    26,
       0,     0,    14,     0,    13,     0,     0,    32,     0,     0,
      11,    36,    37,   114,   120,   119,     0,     0,     0,   103,
     102,   117,   118,   115,   121,    27,    21,     0,    28,    29,
      17,    23,    22,     0,     0,     0,    55,     0,    56,    57,
       0,     0,    44,    39,    51,     0,    52,    42,    40,    41,
       0,    43,     0,    38,    12,    35,   110,   111,     0,     0,
       0,     0,     0,     0,     0,     0,    30,     0,     0,    63,
      64,     0,    80,     0,     0,     0,    69,    76,    75,    74,
       0,     0,    71,     0,    92,    93,     0,   100,    70,     0,
      66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    59,     0,    48,    31,   108,   109,   104,   105,   106,
     107,     0,     0,     0,    60,     0,    85,     0,     0,    82,
       0,    79,     0,    94,    95,     0,    72,    73,    78,    77,
      91,     0,     0,     0,    65,     0,     0,   136,   137,     0,
       0,     0,     0,   125,     0,     0,     0,     0,   127,     0,
       0,    53,     0,    45,     0,    46,    25,   116,     0,    62,
     113,     0,    80,    87,    81,     0,     0,     0,     0,    97,
      89,    90,     0,    67,    68,   129,   132,     0,     0,     0,
     124,     0,   135,     0,   126,     0,    58,    50,     0,     0,
       0,     0,     0,     0,    98,    99,    96,   101,     0,     0,
     128,     0,     0,     0,    47,     0,     0,    86,   112,    88,
      83,   130,   131,   133,   134,     0,    49,     0,     0,     0,
      61,    84,    54
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -182,  -182,  -182,  -182,  -182,  -182,  -182,   314,  -182,  -182,
    -182,   280,  -170,   -24,  -182,   121,    84,  -182,  -182,  -182,
     274,  -182,  -182,  -182,  -182,  -182,  -182,  -182,  -182,    71,
    -182,    79,   172,  -182,  -182,   153,  -182,  -182,   -68,  -181,
     127,  -182,  -182,  -182,  -182,  -182,  -182,  -182,  -182,  -182,
    -182,  -182,  -182,   -67,   -19,  -182,  -182,  -182,  -182,   216,
     -72,   -14,   318,  -182,   -80,  -182,  -182,  -127,  -123
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,     2,     6,     7,     8,    15,    46,    11,    23,
      30,    31,    32,    65,    33,    38,    47,    48,    49,    50,
      51,    52,    82,   142,   195,   228,    83,    84,    85,   140,
      86,   108,   109,    87,   129,   130,    88,    89,   169,   170,
     160,   161,   117,   118,   119,   120,   121,   122,   123,   124,
     163,   125,   208,   126,    58,   201,    59,    60,    61,    62,
      63,    64,    66,    91,   134,   135,   138,   180,   181
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      20,   137,   127,   127,    19,   127,   116,   128,    35,   186,
     131,    19,   111,   187,    19,   171,    68,    69,    39,    13,
       3,    71,    19,   111,   227,   112,     4,    19,     9,    35,
     113,    19,    90,    26,    27,    28,   112,    96,    97,   154,
     127,   113,   155,   106,   159,    14,    19,    12,   132,   172,
       5,   127,   250,    19,   168,   185,    37,    16,   189,   110,
     127,   107,   114,   115,   127,   179,   133,   133,   144,   179,
     158,   141,    29,   114,   115,   256,   143,   261,   139,   145,
     146,   147,   148,   149,   150,   151,   152,    21,   153,   127,
     136,   239,   174,   204,   238,   175,   242,   184,   241,    19,
     111,   191,    17,   127,   192,    19,    34,    19,   131,    22,
     127,   260,   127,   112,   155,   219,   262,   179,   113,   192,
     190,   133,    24,    19,   133,    53,    54,   177,   178,    72,
     127,    42,    43,    25,   159,   206,   207,    37,   200,    44,
      45,   110,    92,   205,   202,    94,   209,    36,    40,    41,
     114,   115,   210,   211,   212,    55,    93,   214,   156,   157,
      67,   127,   162,    56,    57,    98,    99,    19,   105,    53,
      54,    54,    19,   101,   102,   103,   102,   103,   226,   229,
      35,    73,    74,    75,   173,   166,   127,   234,   235,    76,
      77,    98,    99,   165,    78,    79,    80,    81,   167,    55,
     102,   103,    14,   216,   217,   182,   243,    56,    57,   176,
      98,    99,   248,   183,    98,    99,   188,   100,   101,   102,
     103,   100,   101,   102,   103,   -34,    26,    27,    28,   193,
     203,    35,   110,   196,   194,    98,    99,   197,   215,    98,
      99,   141,   100,   101,   102,   103,   100,   101,   102,   103,
     -33,    26,    27,    28,   218,   220,    98,    99,   237,   224,
      98,    99,   246,   100,   101,   102,   103,   100,   101,   102,
     103,   222,   223,   230,   231,   221,    98,    99,   236,   255,
      98,    99,   104,   100,   101,   102,   103,   100,   101,   102,
     103,   244,   245,   240,   178,   177,    98,    99,   198,   247,
      98,    99,   225,   100,   101,   102,   103,   100,   101,   102,
     103,    17,   249,   251,   252,   233,   258,    26,    27,    28,
     253,   254,    10,    70,    95,   257,   259,   199,   213,   232,
     164,    18
};

static const yytype_int16 yycheck[] =
{
      14,    81,    74,    75,     3,    77,    74,    75,    22,   136,
      77,     3,     4,   136,     3,    19,    40,    41,    12,     7,
       0,    45,     3,     4,   194,    17,     0,     3,     6,    43,
      22,     3,    46,     9,    10,    11,    17,    56,    57,    46,
     112,    22,    49,    67,   112,    33,     3,     3,    47,    53,
      24,   123,   233,     3,    46,   135,    50,    41,   138,    73,
     132,    50,    54,    55,   136,   132,    80,    81,    92,   136,
      51,    85,    48,    54,    55,   245,    90,   258,    50,    98,
      99,   100,   101,   102,   103,   104,   105,     6,   107,   161,
      47,   218,    46,   161,   217,    49,   223,    47,   221,     3,
       4,    46,     3,   175,    49,     3,    22,     3,   175,    47,
     182,    46,   184,    17,    49,   182,    46,   184,    22,    49,
     139,   135,    34,     3,   138,     5,     6,    25,    26,    45,
     202,    48,    49,     3,   202,    15,    16,    50,   157,    48,
      49,   155,    49,   162,   158,     8,   165,    46,    27,    28,
      54,    55,   171,   172,   173,    35,    46,   176,    46,    47,
      39,   233,    47,    43,    44,    29,    30,     3,    50,     5,
       6,     6,     3,    37,    38,    39,    38,    39,   192,   198,
     194,    12,    13,    14,    50,    46,   258,   206,   207,    20,
      21,    29,    30,    47,    25,    26,    27,    28,    46,    35,
      38,    39,    33,    48,    49,    47,   225,    43,    44,    53,
      29,    30,   231,    46,    29,    30,    46,    36,    37,    38,
      39,    36,    37,    38,    39,     8,     9,    10,    11,    46,
      18,   245,   246,    52,    47,    29,    30,    52,    48,    29,
      30,   255,    36,    37,    38,    39,    36,    37,    38,    39,
       8,     9,    10,    11,    49,    46,    29,    30,    52,    46,
      29,    30,    52,    36,    37,    38,    39,    36,    37,    38,
      39,    48,    49,    48,    49,    49,    29,    30,    48,    52,
      29,    30,    51,    36,    37,    38,    39,    36,    37,    38,
      39,    48,    49,    48,    26,    25,    29,    30,    51,    46,
      29,    30,    51,    36,    37,    38,    39,    36,    37,    38,
      39,     3,    18,    48,    48,    48,    23,     9,    10,    11,
      48,    48,     8,    43,    50,   246,   255,   155,   175,   202,
     114,    13
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    57,    58,     0,     0,    24,    59,    60,    61,     6,
      63,    64,     3,     7,    33,    62,    41,     3,   118,     3,
     117,     6,    47,    65,    34,     3,     9,    10,    11,    48,
      66,    67,    68,    70,    72,   117,    46,    50,    71,    12,
      71,    71,    48,    49,    48,    49,    63,    72,    73,    74,
      75,    76,    77,     5,     6,    35,    43,    44,   110,   112,
     113,   114,   115,   116,   117,    69,   118,    71,    69,    69,
      67,    69,    72,    12,    13,    14,    20,    21,    25,    26,
      27,    28,    78,    82,    83,    84,    86,    89,    92,    93,
     117,   119,    49,    46,     8,    76,   110,   110,    29,    30,
      36,    37,    38,    39,    51,    50,    69,    50,    87,    88,
     117,     4,    17,    22,    54,    55,    94,    98,    99,   100,
     101,   102,   103,   104,   105,   107,   109,   116,    94,    90,
      91,   109,    47,   117,   120,   121,    47,   120,   122,    50,
      85,   117,    79,   117,    69,   110,   110,   110,   110,   110,
     110,   110,   110,   110,    46,    49,    46,    47,    51,    94,
      96,    97,    47,   106,   115,    47,    46,    46,    46,    94,
      95,    19,    53,    50,    46,    49,    53,    25,    26,   109,
     123,   124,    47,    46,    47,   120,   123,   124,    46,   120,
     110,    46,    49,    46,    47,    80,    52,    52,    51,    88,
     110,   111,   117,    18,    94,   110,    15,    16,   108,   110,
     110,   110,   110,    91,   110,    48,    48,    49,    49,   109,
      46,    49,    48,    49,    46,    51,   117,    68,    81,   110,
      48,    49,    96,    48,   110,   110,    48,    52,   124,   123,
      48,   124,   123,   110,    48,    49,    52,    46,   110,    18,
      95,    48,    48,    48,    48,    52,    68,    87,    23,    85,
      46,    95,    46
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    56,    57,    58,    58,    59,    61,    60,    60,    62,
      63,    63,    64,    65,    65,    65,    65,    66,    66,    67,
      68,    69,    70,    70,    70,    71,    71,    72,    72,    72,
      72,    73,    73,    74,    74,    75,    75,    76,    76,    77,
      77,    77,    77,    77,    77,    78,    79,    80,    80,    81,
      81,    82,    82,    83,    83,    84,    84,    84,    85,    85,
      86,    86,    87,    87,    88,    89,    90,    90,    91,    92,
      93,    94,    94,    94,    94,    94,    94,    95,    95,    96,
      96,    97,    97,    98,    98,    99,    99,   100,   100,   101,
     102,   103,   104,   104,   105,   106,   107,   108,   108,   108,
     109,   109,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   111,   111,   112,   113,   113,   113,   114,   114,
     115,   116,   117,   118,   119,   119,   119,   119,   120,   120,
     121,   121,   121,   122,   122,   122,   123,   124
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     0,     6,     0,     2,     1,     3,
       2,     0,     7,     3,     3,     2,     0,     3,     1,     1,
       1,     1,     3,     3,     1,     5,     0,     3,     3,     3,
       4,     3,     1,     1,     0,     2,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     3,     2,     3,     0,     3,
       1,     1,     1,     3,     8,     1,     1,     1,     3,     1,
       3,     8,     3,     1,     1,     3,     1,     3,     3,     2,
       2,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       0,     2,     1,     5,     7,     2,     5,     3,     5,     3,
       3,     2,     1,     1,     2,     1,     4,     1,     2,     2,
       1,     4,     1,     1,     3,     3,     3,     3,     3,     3,
       2,     2,     3,     1,     1,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     4,     3,     4,     3,
       5,     5,     3,     5,     5,     3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= tEOF)
    {
      yychar = tEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 5: /* timescale_compiler_directive: "`timescale" "unsigned number" "identifier" '/' "unsigned number" "identifier"  */
#line 218 "../src/vlog/vlog-parse.y"
                {
                   set_timescale((yyvsp[-4].str), (yyvsp[-3].str), (yyvsp[-1].str), (yyvsp[0].str), &(yyloc));
                }
#line 1988 "src/vlog/vlog-parse.c"
    break;

  case 6: /* $@1: %empty  */
#line 223 "../src/vlog/vlog-parse.y"
                { root = vlog_new(V_MODULE); }
#line 1994 "src/vlog/vlog-parse.c"
    break;

  case 7: /* description: $@1 module_declaration  */
#line 223 "../src/vlog/vlog-parse.y"
                                                                  { YYACCEPT; }
#line 2000 "src/vlog/vlog-parse.c"
    break;

  case 8: /* description: "end of file"  */
#line 224 "../src/vlog/vlog-parse.y"
                     { root = NULL; }
#line 2006 "src/vlog/vlog-parse.c"
    break;

  case 12: /* module_declaration: attr_list_opt "module" external_identifier module_port_list_opt ';' module_item_list_opt "endmodule"  */
#line 237 "../src/vlog/vlog-parse.y"
                {
                   ident_t qual = ident_prefix(lib_name(lib_work()),
                                               (yyvsp[-4].pair).right, '.');

                   (yyval.vlog) = root;
                   vlog_set_ident((yyval.vlog), qual);
                   vlog_set_ident2((yyval.vlog), (yyvsp[-4].pair).left);
                   vlog_set_loc((yyval.vlog), &(yyloc));

                   for (node_list_t *it = (yyvsp[-3].list); it; it = it->next)
                      add_port((yyval.vlog), it->value);
                   node_list_free((yyvsp[-3].list));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next) {
                      if (is_decl(it->value))
                         vlog_add_decl((yyval.vlog), it->value);
                      else
                         vlog_add_stmt((yyval.vlog), it->value);
                   }
                   node_list_free((yyvsp[-1].list));
                }
#line 2032 "src/vlog/vlog-parse.c"
    break;

  case 13: /* module_port_list_opt: '(' list_of_port_declarations ')'  */
#line 261 "../src/vlog/vlog-parse.y"
                                                  { (yyval.list) = (yyvsp[-1].list); }
#line 2038 "src/vlog/vlog-parse.c"
    break;

  case 14: /* module_port_list_opt: '(' list_of_ports ')'  */
#line 262 "../src/vlog/vlog-parse.y"
                                      { (yyval.list) = (yyvsp[-1].list); }
#line 2044 "src/vlog/vlog-parse.c"
    break;

  case 15: /* module_port_list_opt: '(' ')'  */
#line 263 "../src/vlog/vlog-parse.y"
                        { (yyval.list) = NULL; }
#line 2050 "src/vlog/vlog-parse.c"
    break;

  case 16: /* module_port_list_opt: %empty  */
#line 264 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 2056 "src/vlog/vlog-parse.c"
    break;

  case 17: /* list_of_ports: list_of_ports ',' port  */
#line 268 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2065 "src/vlog/vlog-parse.c"
    break;

  case 18: /* list_of_ports: port  */
#line 272 "../src/vlog/vlog-parse.y"
                     { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2071 "src/vlog/vlog-parse.c"
    break;

  case 19: /* port: port_reference  */
#line 275 "../src/vlog/vlog-parse.y"
                               { (yyval.vlog) = (yyvsp[0].vlog); }
#line 2077 "src/vlog/vlog-parse.c"
    break;

  case 20: /* port_reference: identifier  */
#line 279 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 2087 "src/vlog/vlog-parse.c"
    break;

  case 21: /* port_identifier: external_identifier  */
#line 288 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_PORT_DECL);
                   vlog_set_loc((yyval.vlog), &(yylsp[0]));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].pair).left);
                   vlog_set_ident2((yyval.vlog), (yyvsp[0].pair).right);
                }
#line 2098 "src/vlog/vlog-parse.c"
    break;

  case 22: /* list_of_port_declarations: list_of_port_declarations ',' port_declaration_head  */
#line 298 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_concat(&(yyval.list), (yyvsp[0].list));
                }
#line 2107 "src/vlog/vlog-parse.c"
    break;

  case 23: /* list_of_port_declarations: list_of_port_declarations ',' port_identifier  */
#line 303 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   clone_port(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2116 "src/vlog/vlog-parse.c"
    break;

  case 24: /* list_of_port_declarations: port_declaration_head  */
#line 307 "../src/vlog/vlog-parse.y"
                                      { (yyval.list) = (yyvsp[0].list); }
#line 2122 "src/vlog/vlog-parse.c"
    break;

  case 25: /* range_opt: '[' expression ':' expression ']'  */
#line 311 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_DIMENSION);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_DIM_PACKED);
                   vlog_set_left((yyval.vlog), (yyvsp[-3].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[-1].vlog));
                }
#line 2134 "src/vlog/vlog-parse.c"
    break;

  case 26: /* range_opt: %empty  */
#line 318 "../src/vlog/vlog-parse.y"
                            { (yyval.vlog) = NULL; }
#line 2140 "src/vlog/vlog-parse.c"
    break;

  case 27: /* port_declaration_head: "input" range_opt port_identifier  */
#line 323 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_INPUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = node_list_single((yyvsp[0].vlog));
                }
#line 2152 "src/vlog/vlog-parse.c"
    break;

  case 28: /* port_declaration_head: "output" range_opt port_identifier  */
#line 331 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_OUTPUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = node_list_single((yyvsp[0].vlog));
                }
#line 2164 "src/vlog/vlog-parse.c"
    break;

  case 29: /* port_declaration_head: "inout" range_opt port_identifier  */
#line 339 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_INOUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = node_list_single((yyvsp[0].vlog));
                }
#line 2176 "src/vlog/vlog-parse.c"
    break;

  case 30: /* port_declaration_head: "output" "reg" range_opt port_identifier  */
#line 347 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[0].vlog), V_PORT_OUTPUT);
                   if ((yyvsp[-1].vlog) != NULL)
                      vlog_add_range((yyvsp[0].vlog), (yyvsp[-1].vlog));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));

                   vlog_node_t reg = vlog_new(V_VAR_DECL);
                   vlog_set_loc(reg, &(yyloc));
                   vlog_set_ident(reg, vlog_ident((yyvsp[0].vlog)));

                   node_list_append(&(yyval.list), reg);
                }
#line 2195 "src/vlog/vlog-parse.c"
    break;

  case 31: /* port_declaration: port_declaration_head ',' port_identifier  */
#line 365 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   clone_port(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2204 "src/vlog/vlog-parse.c"
    break;

  case 34: /* module_item_list_opt: %empty  */
#line 374 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 2210 "src/vlog/vlog-parse.c"
    break;

  case 35: /* module_item_list: module_item_list module_item  */
#line 379 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                   node_list_concat(&(yyval.list), (yyvsp[0].list));
                }
#line 2219 "src/vlog/vlog-parse.c"
    break;

  case 39: /* module_or_generate_item: attr_list_opt module_or_generate_item_declaration  */
#line 392 "../src/vlog/vlog-parse.y"
                                                                  { (yyval.list) = (yyvsp[0].list); }
#line 2225 "src/vlog/vlog-parse.c"
    break;

  case 40: /* module_or_generate_item: attr_list_opt always_construct  */
#line 393 "../src/vlog/vlog-parse.y"
                                               { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2231 "src/vlog/vlog-parse.c"
    break;

  case 41: /* module_or_generate_item: attr_list_opt initial_construct  */
#line 394 "../src/vlog/vlog-parse.y"
                                                { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2237 "src/vlog/vlog-parse.c"
    break;

  case 42: /* module_or_generate_item: attr_list_opt continuous_assign  */
#line 395 "../src/vlog/vlog-parse.y"
                                                { (yyval.list) = (yyvsp[0].list); }
#line 2243 "src/vlog/vlog-parse.c"
    break;

  case 43: /* module_or_generate_item: attr_list_opt gate_instantiation  */
#line 396 "../src/vlog/vlog-parse.y"
                                                 { (yyval.list) = (yyvsp[0].list); }
#line 2249 "src/vlog/vlog-parse.c"
    break;

  case 44: /* module_or_generate_item: attr_list_opt module_instantiation  */
#line 397 "../src/vlog/vlog-parse.y"
                                                   { (yyval.list) = (yyvsp[0].list); }
#line 2255 "src/vlog/vlog-parse.c"
    break;

  case 45: /* module_instantiation: identifier module_instance ';'  */
#line 402 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_ident2((yyvsp[-1].vlog), (yyvsp[-2].ident));
                   (yyval.list) = node_list_single((yyvsp[-1].vlog));
                }
#line 2264 "src/vlog/vlog-parse.c"
    break;

  case 46: /* module_instance: identifier list_of_port_connections_opt  */
#line 410 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_MOD_INST);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[-1].ident));

                   for (node_list_t *it = (yyvsp[0].list); it; it = it->next)
                      vlog_add_param((yyval.vlog), it->value);

                   node_list_free((yyvsp[0].list));
                }
#line 2279 "src/vlog/vlog-parse.c"
    break;

  case 47: /* list_of_port_connections_opt: '(' list_of_port_connections ')'  */
#line 423 "../src/vlog/vlog-parse.y"
                                                 { (yyval.list) = (yyvsp[-1].list); }
#line 2285 "src/vlog/vlog-parse.c"
    break;

  case 48: /* list_of_port_connections_opt: %empty  */
#line 424 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 2291 "src/vlog/vlog-parse.c"
    break;

  case 49: /* list_of_port_connections: list_of_port_connections ',' port_reference  */
#line 429 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2300 "src/vlog/vlog-parse.c"
    break;

  case 50: /* list_of_port_connections: port_reference  */
#line 433 "../src/vlog/vlog-parse.y"
                               { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2306 "src/vlog/vlog-parse.c"
    break;

  case 53: /* net_declaration: net_type list_of_net_identifiers ';'  */
#line 443 "../src/vlog/vlog-parse.y"
                {
                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_set_subkind(it->value, (yyvsp[-2].kind));

                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2317 "src/vlog/vlog-parse.c"
    break;

  case 54: /* net_declaration: net_type '[' expression ':' expression ']' list_of_net_identifiers ';'  */
#line 451 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t r = vlog_new(V_DIMENSION);
                   vlog_set_loc(r, &(yyloc));
                   vlog_set_subkind(r, V_DIM_PACKED);
                   vlog_set_left(r, (yyvsp[-5].vlog));
                   vlog_set_right(r, (yyvsp[-3].vlog));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next) {
                      vlog_add_range(it->value, r);
                      vlog_set_datatype(it->value, DT_LOGIC);
                      vlog_set_subkind(it->value, (yyvsp[-7].kind));
                   }

                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2337 "src/vlog/vlog-parse.c"
    break;

  case 55: /* net_type: "wire"  */
#line 468 "../src/vlog/vlog-parse.y"
                      { (yyval.kind) = V_NET_WIRE; }
#line 2343 "src/vlog/vlog-parse.c"
    break;

  case 56: /* net_type: "supply0"  */
#line 469 "../src/vlog/vlog-parse.y"
                         { (yyval.kind) = V_NET_SUPPLY0; }
#line 2349 "src/vlog/vlog-parse.c"
    break;

  case 57: /* net_type: "supply1"  */
#line 470 "../src/vlog/vlog-parse.y"
                         { (yyval.kind) = V_NET_SUPPLY1; }
#line 2355 "src/vlog/vlog-parse.c"
    break;

  case 58: /* list_of_net_identifiers: list_of_net_identifiers ',' identifier  */
#line 475 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t v = vlog_new(V_NET_DECL);
                   vlog_set_loc(v, &(yylsp[0]));
                   vlog_set_ident(v, (yyvsp[0].ident));

                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), v);
                }
#line 2368 "src/vlog/vlog-parse.c"
    break;

  case 59: /* list_of_net_identifiers: identifier  */
#line 484 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t v = vlog_new(V_NET_DECL);
                   vlog_set_loc(v, &(yyloc));
                   vlog_set_ident(v, (yyvsp[0].ident));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), v);
                }
#line 2381 "src/vlog/vlog-parse.c"
    break;

  case 60: /* reg_declaration: "reg" list_of_variable_identifiers ';'  */
#line 496 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2389 "src/vlog/vlog-parse.c"
    break;

  case 61: /* reg_declaration: "reg" '[' expression ':' expression ']' list_of_variable_identifiers ';'  */
#line 501 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t r = vlog_new(V_DIMENSION);
                   vlog_set_loc(r, &(yyloc));
                   vlog_set_subkind(r, V_DIM_PACKED);
                   vlog_set_left(r, (yyvsp[-5].vlog));
                   vlog_set_right(r, (yyvsp[-3].vlog));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_range(it->value, r);

                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2406 "src/vlog/vlog-parse.c"
    break;

  case 62: /* list_of_variable_identifiers: list_of_variable_identifiers ',' variable_type  */
#line 517 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2415 "src/vlog/vlog-parse.c"
    break;

  case 63: /* list_of_variable_identifiers: variable_type  */
#line 522 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2424 "src/vlog/vlog-parse.c"
    break;

  case 64: /* variable_type: identifier  */
#line 529 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_VAR_DECL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 2434 "src/vlog/vlog-parse.c"
    break;

  case 65: /* continuous_assign: "assign" list_of_net_assignments ';'  */
#line 537 "../src/vlog/vlog-parse.y"
                                                    { (yyval.list) = (yyvsp[-1].list); }
#line 2440 "src/vlog/vlog-parse.c"
    break;

  case 66: /* list_of_net_assignments: net_assignment  */
#line 541 "../src/vlog/vlog-parse.y"
                               { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2446 "src/vlog/vlog-parse.c"
    break;

  case 67: /* list_of_net_assignments: list_of_net_assignments ',' net_assignment  */
#line 543 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2455 "src/vlog/vlog-parse.c"
    break;

  case 68: /* net_assignment: lvalue '=' expression  */
#line 550 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_ASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__assign#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2470 "src/vlog/vlog-parse.c"
    break;

  case 69: /* always_construct: "always" statement  */
#line 564 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_ALWAYS);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__always#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2484 "src/vlog/vlog-parse.c"
    break;

  case 70: /* initial_construct: "initial" statement  */
#line 577 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_INITIAL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__initial#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2498 "src/vlog/vlog-parse.c"
    break;

  case 78: /* statement_or_null: ';'  */
#line 598 "../src/vlog/vlog-parse.y"
                    { (yyval.vlog) = NULL; }
#line 2504 "src/vlog/vlog-parse.c"
    break;

  case 80: /* list_of_statements_opt: %empty  */
#line 604 "../src/vlog/vlog-parse.y"
                { (yyval.list) = NULL; }
#line 2510 "src/vlog/vlog-parse.c"
    break;

  case 81: /* list_of_statements: list_of_statements statement  */
#line 609 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2519 "src/vlog/vlog-parse.c"
    break;

  case 82: /* list_of_statements: statement  */
#line 614 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2528 "src/vlog/vlog-parse.c"
    break;

  case 83: /* conditional_statement: "if" '(' expression ')' statement_or_null  */
#line 622 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t c = vlog_new(V_COND);
                   vlog_set_loc(c, &(yylsp[-2]));
                   vlog_set_value(c, (yyvsp[-2].vlog));
                   if ((yyvsp[0].vlog) != NULL)
                      vlog_add_stmt(c, (yyvsp[0].vlog));

                   (yyval.vlog) = vlog_new(V_IF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_cond((yyval.vlog), c);
                }
#line 2544 "src/vlog/vlog-parse.c"
    break;

  case 84: /* conditional_statement: "if" '(' expression ')' statement_or_null "else" statement_or_null  */
#line 634 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t c1 = vlog_new(V_COND);
                   vlog_set_loc(c1, &(yylsp[-4]));
                   vlog_set_value(c1, (yyvsp[-4].vlog));
                   if ((yyvsp[-2].vlog) != NULL)
                      vlog_add_stmt(c1, (yyvsp[-2].vlog));

                   vlog_node_t c2 = vlog_new(V_COND);
                   vlog_set_loc(c2, &(yylsp[-1]));
                   if ((yyvsp[0].vlog) != NULL)
                      vlog_add_stmt(c2, (yyvsp[0].vlog));

                   (yyval.vlog) = vlog_new(V_IF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_cond((yyval.vlog), c1);
                   vlog_add_cond((yyval.vlog), c2);
                }
#line 2566 "src/vlog/vlog-parse.c"
    break;

  case 85: /* system_task_enable: "system task identifier" ';'  */
#line 655 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SYSTASK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), ident_new((yyvsp[-1].str)));

                   free((yyvsp[-1].str));
                }
#line 2578 "src/vlog/vlog-parse.c"
    break;

  case 86: /* system_task_enable: "system task identifier" '(' list_of_expressions ')' ';'  */
#line 663 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SYSTASK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), ident_new((yyvsp[-4].str)));

                   for (node_list_t *it = (yyvsp[-2].list); it; it = it->next)
                      vlog_add_param((yyval.vlog), it->value);
                   node_list_free((yyvsp[-2].list));

                   free((yyvsp[-4].str));
                }
#line 2594 "src/vlog/vlog-parse.c"
    break;

  case 87: /* seq_block: "begin" list_of_statements_opt "end"  */
#line 677 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SEQ_BLOCK);
                   vlog_set_loc((yyval.vlog), &(yyloc));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_stmt((yyval.vlog), it->value);
                   node_list_free((yyvsp[-1].list));
                }
#line 2607 "src/vlog/vlog-parse.c"
    break;

  case 88: /* seq_block: "begin" ':' identifier list_of_statements_opt "end"  */
#line 686 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SEQ_BLOCK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[-2].ident));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_stmt((yyval.vlog), it->value);
                   node_list_free((yyvsp[-1].list));
                }
#line 2621 "src/vlog/vlog-parse.c"
    break;

  case 89: /* nonblocking_assignment: lvalue "<=" expression  */
#line 699 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NBASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2632 "src/vlog/vlog-parse.c"
    break;

  case 90: /* blocking_assignment: lvalue '=' expression  */
#line 709 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_ASSIGN_EQUALS);
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2644 "src/vlog/vlog-parse.c"
    break;

  case 91: /* procedural_timing_control_statement: delay_or_event_control statement_or_null  */
#line 720 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_TIMING);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_value((yyval.vlog), (yyvsp[-1].vlog));
                   if ((yyvsp[0].vlog) != NULL)
                      vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2656 "src/vlog/vlog-parse.c"
    break;

  case 94: /* delay_control: '#' delay_value  */
#line 735 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_DELAY_CONTROL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2666 "src/vlog/vlog-parse.c"
    break;

  case 96: /* event_control: '@' '(' event_expression ')'  */
#line 745 "../src/vlog/vlog-parse.y"
                                            { (yyval.vlog) = (yyvsp[-1].vlog); }
#line 2672 "src/vlog/vlog-parse.c"
    break;

  case 97: /* event_expression: expression  */
#line 749 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_LEVEL);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2683 "src/vlog/vlog-parse.c"
    break;

  case 98: /* event_expression: "posedge" expression  */
#line 756 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_POSEDGE);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2694 "src/vlog/vlog-parse.c"
    break;

  case 99: /* event_expression: "negedge" expression  */
#line 763 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_NEGEDGE);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2705 "src/vlog/vlog-parse.c"
    break;

  case 100: /* lvalue: hierarchical_identifier  */
#line 772 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 2715 "src/vlog/vlog-parse.c"
    break;

  case 101: /* lvalue: hierarchical_identifier '[' expression ']'  */
#line 778 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BIT_SELECT);
                   vlog_set_ident((yyval.vlog), (yyvsp[-3].ident));
                   vlog_add_param((yyval.vlog), (yyvsp[-1].vlog));
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 2726 "src/vlog/vlog-parse.c"
    break;

  case 104: /* expression: expression '|' expression  */
#line 789 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_OR);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2738 "src/vlog/vlog-parse.c"
    break;

  case 105: /* expression: expression '&' expression  */
#line 797 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_AND);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2750 "src/vlog/vlog-parse.c"
    break;

  case 106: /* expression: expression '+' expression  */
#line 805 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_PLUS);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2762 "src/vlog/vlog-parse.c"
    break;

  case 107: /* expression: expression '-' expression  */
#line 813 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_MINUS);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2774 "src/vlog/vlog-parse.c"
    break;

  case 108: /* expression: expression "===" expression  */
#line 821 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_CASE_EQ);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2786 "src/vlog/vlog-parse.c"
    break;

  case 109: /* expression: expression "!==" expression  */
#line 829 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BINARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_BINARY_CASE_NEQ);
                   vlog_set_left((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_right((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2798 "src/vlog/vlog-parse.c"
    break;

  case 110: /* expression: '~' expression  */
#line 837 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_UNARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_UNARY_BITNEG);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2809 "src/vlog/vlog-parse.c"
    break;

  case 111: /* expression: '!' expression  */
#line 844 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_UNARY);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_UNARY_NOT);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2820 "src/vlog/vlog-parse.c"
    break;

  case 112: /* list_of_expressions: list_of_expressions ',' expression  */
#line 854 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2829 "src/vlog/vlog-parse.c"
    break;

  case 113: /* list_of_expressions: expression  */
#line 859 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2838 "src/vlog/vlog-parse.c"
    break;

  case 114: /* string: "string"  */
#line 866 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_STRING);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   (yyvsp[0].str)[strlen((yyvsp[0].str)) - 1] = '\0';
                   vlog_set_text((yyval.vlog), (yyvsp[0].str) + 1);
                   free((yyvsp[0].str));
                }
#line 2850 "src/vlog/vlog-parse.c"
    break;

  case 115: /* primary: hierarchical_identifier  */
#line 876 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 2860 "src/vlog/vlog-parse.c"
    break;

  case 116: /* primary: hierarchical_identifier '[' expression ']'  */
#line 882 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_BIT_SELECT);
                   vlog_set_ident((yyval.vlog), (yyvsp[-3].ident));
                   vlog_add_param((yyval.vlog), (yyvsp[-1].vlog));
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 2871 "src/vlog/vlog-parse.c"
    break;

  case 119: /* number: "number"  */
#line 893 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NUMBER);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_number((yyval.vlog), number_new((yyvsp[0].str)));
                   free((yyvsp[0].str));
                }
#line 2882 "src/vlog/vlog-parse.c"
    break;

  case 120: /* decimal_number: "unsigned number"  */
#line 902 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NUMBER);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_number((yyval.vlog), number_new((yyvsp[0].str)));
                   free((yyvsp[0].str));
                }
#line 2893 "src/vlog/vlog-parse.c"
    break;

  case 122: /* identifier: "identifier"  */
#line 915 "../src/vlog/vlog-parse.y"
                {
                   (yyval.ident) = ident_new((yyvsp[0].str));
                   free((yyvsp[0].str));
                }
#line 2902 "src/vlog/vlog-parse.c"
    break;

  case 123: /* external_identifier: "identifier"  */
#line 923 "../src/vlog/vlog-parse.y"
                {
                   (yyval.pair).left = ident_new((yyvsp[0].str));
                   for (char *p = (yyvsp[0].str); *p; p++)
                      *p = toupper_iso88591(*p);
                   (yyval.pair).right = ident_new((yyvsp[0].str));
                   free((yyvsp[0].str));
                }
#line 2914 "src/vlog/vlog-parse.c"
    break;

  case 124: /* gate_instantiation: "pulldown" pulldown_strength pull_gate_instance ';'  */
#line 934 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLDOWN);

                   for (node_list_t *it = (yyvsp[-2].list); it; it = it->next)
                      vlog_add_param((yyvsp[-1].vlog), it->value);
                   node_list_free((yyvsp[-2].list));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 2929 "src/vlog/vlog-parse.c"
    break;

  case 125: /* gate_instantiation: "pulldown" pull_gate_instance ';'  */
#line 945 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLDOWN);

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 2940 "src/vlog/vlog-parse.c"
    break;

  case 126: /* gate_instantiation: "pullup" pullup_strength pull_gate_instance ';'  */
#line 952 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLUP);

                   for (node_list_t *it = (yyvsp[-2].list); it; it = it->next)
                      vlog_add_param((yyvsp[-1].vlog), it->value);
                   node_list_free((yyvsp[-2].list));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 2955 "src/vlog/vlog-parse.c"
    break;

  case 127: /* gate_instantiation: "pullup" pull_gate_instance ';'  */
#line 963 "../src/vlog/vlog-parse.y"
                {
                   vlog_set_subkind((yyvsp[-1].vlog), V_GATE_PULLUP);

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 2966 "src/vlog/vlog-parse.c"
    break;

  case 128: /* pull_gate_instance: identifier '(' lvalue ')'  */
#line 973 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_GATE_INST);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[-3].ident));
                   vlog_set_target((yyval.vlog), (yyvsp[-1].vlog));
                }
#line 2977 "src/vlog/vlog-parse.c"
    break;

  case 129: /* pull_gate_instance: '(' lvalue ')'  */
#line 980 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_GATE_INST);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-1].vlog));
                }
#line 2987 "src/vlog/vlog-parse.c"
    break;

  case 130: /* pulldown_strength: '(' strength0 ',' strength1 ')'  */
#line 989 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 2997 "src/vlog/vlog-parse.c"
    break;

  case 131: /* pulldown_strength: '(' strength1 ',' strength0 ')'  */
#line 995 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3007 "src/vlog/vlog-parse.c"
    break;

  case 132: /* pulldown_strength: '(' strength0 ')'  */
#line 1001 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3016 "src/vlog/vlog-parse.c"
    break;

  case 133: /* pullup_strength: '(' strength0 ',' strength1 ')'  */
#line 1009 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3026 "src/vlog/vlog-parse.c"
    break;

  case 134: /* pullup_strength: '(' strength1 ',' strength0 ')'  */
#line 1015 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-3].vlog));
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3036 "src/vlog/vlog-parse.c"
    break;

  case 135: /* pullup_strength: '(' strength1 ')'  */
#line 1021 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 3045 "src/vlog/vlog-parse.c"
    break;

  case 136: /* strength0: "supply0"  */
#line 1027 "../src/vlog/vlog-parse.y"
                         { (yyval.vlog) = make_strength(V_STRENGTH_SUPPLY0, &(yyloc)); }
#line 3051 "src/vlog/vlog-parse.c"
    break;

  case 137: /* strength1: "supply1"  */
#line 1030 "../src/vlog/vlog-parse.y"
                         { (yyval.vlog) = make_strength(V_STRENGTH_SUPPLY1, &(yyloc)); }
#line 3057 "src/vlog/vlog-parse.c"
    break;


#line 3061 "src/vlog/vlog-parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= tEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == tEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 1033 "../src/vlog/vlog-parse.y"


static void yyerror(const char *s)
{
   error_at(&yylloc, "%s", s);
}

static void node_list_concat(node_list_t **a, node_list_t *b)
{
   if (*a == NULL)
      *a = b;
   else if (b != NULL) {
      assert((*a)->tail->next == NULL);
      (*a)->tail->next = b;
      (*a)->tail = b->tail;
   }
}

static void node_list_free(node_list_t *l)
{
   while (l != NULL) {
      node_list_t *next = l->next;
      free(l);
      l = next;
   }
}

static void node_list_append(node_list_t **l, vlog_node_t v)
{
   node_list_t *new = xmalloc(sizeof(node_list_t));
   new->next  = NULL;
   new->value = v;
   new->tail  = new;

   node_list_concat(l, new);
}

static node_list_t *node_list_single(vlog_node_t v)
{
   node_list_t *new = xmalloc(sizeof(node_list_t));
   new->next  = NULL;
   new->value = v;
   new->tail  = new;

   return new;
}

static void set_timescale(const char *unit_value, const char *unit_name,
                          const char *prec_value, const char *prec_name,
                          const loc_t *loc)
{
   // See IEEE 1800-2017 section 22.7 for rules

   struct {
      const char *value;
      const char *name;
      int64_t     parsed;
   } args[] = {
      { unit_value, unit_name },
      { prec_value, prec_name },
   };

   for (int i = 0; i < ARRAY_LEN(args); i++) {
      static const struct {
         const char *name;
         int64_t value;
      } valid_units[] = {
         { "s", INT64_C(60000000000000) },
         { "ms", 1000000000000 },
         { "us", 1000000000 },
         { "ns", 1000000 },
         { "ps", 1000 },
         { "fs", 1 },
      };

      bool name_valid = false;
      for (int j = 0; j < ARRAY_LEN(valid_units); j++) {
         if (strcmp(valid_units[j].name, args[i].name) == 0) {
            args[i].parsed = valid_units[j].value;
            name_valid = true;
            break;
         }
      }

      if (!name_valid)
         error_at(loc, "invalid time unit name '%s'", args[i].name);

      const int scale = atoi(args[i].value);
      if (scale != 1 && scale != 10 && scale != 100) {
         diag_t *d = diag_new(DIAG_ERROR, loc);
         diag_printf(d, "invalid order of magniture in `timescale directive");
         diag_hint(d, NULL, "the valid values are 1, 10, and 100");
         diag_emit(d);
      }

      args[i].parsed *= scale;
   }

   // TODO: do something with parsed scale/precision
}

static void clone_port(node_list_t **list, vlog_node_t p)
{
   node_list_t *last = NULL;
   for (node_list_t *it = *list; it != NULL; it = it->next) {
      if (vlog_kind(it->value) == V_PORT_DECL)
         last = it;
   }

   vlog_set_subkind(p, vlog_subkind(last->value));

   node_list_append(list, p);

   if (last->next && vlog_kind(last->next->value) == V_VAR_DECL) {
      vlog_node_t reg = vlog_new(V_VAR_DECL);
      vlog_set_loc(reg, vlog_loc(p));
      vlog_set_ident(reg, vlog_ident(p));

      node_list_append(list, reg);
   }
}

vlog_node_t vlog_parse(void)
{
   make_new_arena();
   root = NULL;

   scan_as_verilog();

   if (yyparse())
      return NULL;
   else
      return root;
}

void reset_verilog_parser(void)
{
}
